
sub token_c_comments
{ # $text, \%token, $i
    $_[0] =~
        s/ (\/\* (?:[^\*]|[\*](?!\/))+ \*\/) 
         / token_c_comment($1,$_[1], $_[2]) /gsex;
}

sub token_c_comment
{ # $text, \%token, $i
    my $key = "\@rem".$_[2]."\@"; ++$_[2];
    ${$_[1]}{$key} = $_[0];
    return $key;
}

sub token_cc_comments
{ # $text, \%token, $i
    $_[0] =~
        s/ (\/\/ .*) 
         / token_cc_comment($1,$_[1], $_[2]) /gmex;
}

sub token_cc_comment
{ # $text, \%token, $i
    my $key = "\@rem".$_[2]."\@"; ++$_[2];
    ${$_[1]}{$key} = $_[0];
    return $key;
}

sub token_strings
{ # $text, \%token, $i
    $_[0] =~
        s/ (\" (?:[^\\\"]|\\.)+ \") 
         / token_string($1,$_[1], $_[2]) /gsex;
}

sub token_string
{ # $text, \%token, $i
    my $key = "\@str".$_[2]."\@"; ++$_[2];
    ${$_[1]}{$key} = $_[0];
    return $key;
}

sub token_chars
{ # $text, \%token, $i
    $_[0] =~
        s/ (\' (?:[^\\\']|\\.)+ \') 
         / token_char($1,$_[1], $_[2]) /gsex;
}

sub token_char
{ # $text, \%token, $i
    my $key = "\@chr".$_[2]."\@"; ++$_[2];
    ${$_[1]}{$key} = $_[0];
    return $key;
}

sub token_extern_langs
{ # $text, \%token, $i
    $_[0] =~
        s/ (extern \s* \"[^\\\"]+\") 
         / token_extern_lang($1,$_[1], $_[2]) /gsex;
}

sub token_extern_lang
{ # $text, \%token, $i
    my $key = "\@ext".$_[2]."\@"; ++$_[2];
    ${$_[1]}{$key} = $_[0];
    return $key;
}

# about defbodies

sub token_any_macro_defbodies
{ # $text, \%token, $i
    $_[0] =~
        s/ (^[\ \t]*\#[\ \t]*(?:define|if|ifdef|ifndef)[\ \t]*\w+\([\s\w\,]*\)[\ \t]?) ((?:[^\\\n]+|\\\n)*) 
         / $1.&token_any_macro_defbody($2,$_[1], $_[2]) /gmex;
}

sub token_any_macro_defbody
{ # $text, \%token, $i
    my $key = "\@def".$_[2]."\@"; ++$_[2];
    ${$_[1]}{$key} = $_[0];
    return $key;
}

sub token_any_nonmacro_defbodies
{ # $text, \%token, $i
    $_[0] =~
        s/ (^[\ \t]*\#[\ \t]*(?:define|if|ifdef|ifndef)[\ \t]*\w+[\ \t]) ((?:[^\\\n]+|\\\n)*) 
         / $1.&token_any_nonmacro_defbody($2,$_[1], $_[2]) /gmex;
}

sub token_any_nonmacro_defbody
{ # $text, \%token, $i
    my $key = "\@def".$_[2]."\@"; ++$_[2];
    ${$_[1]}{$key} = $_[0];
    return $key;
}

sub token_any_defbodies
{
    token_any_macro_defbodies($_[0],$_[1],$_[2]);
    token_any_nonmacro_defbodies($_[0],$_[1],$_[2]);
}

sub token_iscomplex  
{ 
    return 0 if $_[0] =~ m/^[\s\w\@]*$/; 
    return 1;
}

sub token_complex_macro_defbodies
{# $text, \%token, $i
   $_[0] =~
       s/ (^[\ \t]*\#[\ \t]*(?:define|if|ifdef|ifndef)[\ \t]*\w+\([\s\w\,]*\)[\ \t]?) ((?:[^\\\n]+|\\\n)*) 
        / $1.&token_complex_macro_defbody($2,$_[1], $_[2]) /gmex;
}

sub token_complex_macro_defbody
{ # $text, \%token, $i
    return $_[0] if not token_iscomplex($_[0]);

    my $key = "\@def".$_[2]."\@"; ++$_[2];
    ${$_[1]}{$key} = $_[0];
    return $key;
}

sub token_complex_nonmacro_defbodies
{ # $text, \%token, $i
    $_[0] =~
        s/ (^[\ \t]*\#[\ \t]*(?:define|if|ifdef|ifndef)[\ \t]*\w+[\ \t]) ((?:[^\\\n]+|\\\n)*) 
         / $1.&token_complex_nonmacro_defbody($2,$_[1], $_[2]) /gmex;
}

sub token_complex_nonmacro_defbody
{ # $text, \%token, $i
    return $_[0] if not token_iscomplex($_[0]);

    my $key = "\@def".$_[2]."\@"; ++$_[2];
    ${$_[1]}{$key} = $_[0];
    return $key;
}

sub token_complex_defbodies
{
    token_complex_macro_defbodies($_[0],$_[1],$_[2]);
    token_complex_nonmacro_defbodies($_[0],$_[1],$_[2]);
}

sub token_mark_cpplines
{
    $_[0] =~
        s/ (^ [\ \t]*\#)( .*) $
         / $1."{".$2."}" /mgex;
}

sub token_unmark_cpplines
{
    $_[0] =~
        s/ (^ [\ \t]*\#) ({) ([^}]*) (})
         / $1.$3 /mgex;
}

# simple C sourcecode to be easily parsable
sub token_c_simplify
{ # $text, \%token
    my $i = 100000;
    token_c_comments($_[0],$_[1],$i);
    token_cc_comments($_[0],$_[1],$i);
    token_extern_langs($_[0],$_[1],$i);
    token_strings($_[0],$_[1],$i);
    token_chars($_[0],$_[1],$i);
    token_complex_defbodies($_[0],$_[1],$i);
    token_mark_cpplines($_[0]);
    return $i-100000;
}

# just the reverse of token_c_simplify
sub token_c_unsimplify
{ # $text, \%token
    token_unmark_cpplines($_[0]);
    token_untokenizes ($_[0],$_[1]);
    token_untokenizes ($_[0],$_[1]);
    token_untokenizes ($_[0],$_[1]);
    # untokenize two times since defbodies could contain @tokens@
}

sub token_untokenizes
{ # $text, \%token
    $_[0] =~
        s/ (\@ [a-zA-Z]+ [0-9]+ \@)
         / &token_untokenize1($1,$_[1]) /gmex;
}

sub token_untokenize1
{ # $token, \%token
    if (exists ${$_[1]}{$_[0]})
         { return ${$_[1]}{$_[0]}; }
    else { return $_[1]; }
}

# returns the untokenized version of the $_[0]
sub token_untokenize
{ # args: $text \%token
    $_ = $_[0];

    # untokenize two times since there could be defbodies with @tokens@
    s/ (\@ [a-zA-Z]+ [0-9]+ \@)
     / &token_untokenize1($1,$_[1]) /gmex;

    s/ (\@ [a-zA-Z]+ [0-9]+ \@)
     / &token_untokenize1($1,$_[1]) /gmex;

     return $_;
}

