#! /usr/bin/perl -w

do "tokenccode.pl";

my %opt;
my %shortopt = ( "v" => "verbose", "V" => "version" );
my @files;

# scan away the options
for (@ARGV)
{
    if (/^--(.*)=(.*)/) { $opt{$1} = $2; next; }
    if (/^--no-(.*)/) { $opt{$1} = 0; next; }
    if (/^--(.*)/) { $opt{$1} = 1; next; }
    if (/^-(\w)(.*)/) { 
        if (exists $shortopt{$1}) {
        	my $x = ""; $x = $2 if defined $2; $opt{$shortopt{$1}} = $x;
                next;
        } 
    }
    
    push @files, $_;
}

for $F (@files)
{
    open F, "<$F" or print "$F: can not open input: $!" and next;
    $_ = join("",<F>); close F;
    my %token = ();

    my $count = 
        token_c_simplify($_,\%token);

    # spit out cutted text, the reconstructed text, and the cutted tokens #
    open F, ">$F.zz" or print "$F.zz: can not open output: $!" and next;
    print F $_; close F;

    token_c_unsimplify($_,\%token);
    open F, ">$F.re" or print "$F.re: can not open output: $!" and next;
    print F $_; close F;
    
    open F, ">$F.tk" or print "$F.tk: can not open output: $!" and next;
    for $k (sort keys %token)
    {
        print F "\n",$k;
        my $t = $token{$k};
        $t =~ s/ (^) /$1."     "/gmex;
        print F "\n",$t;
    }
    close F;
    print "$F: ",$count," tokens\n";
}


